#include "otto_platform.h"

static struct mbuf *otto_en_cred_add (struct otto_softc *sc,
	struct mbuf *m, struct sockaddr *dst,
	unsigned char *osrc, unsigned char *odst, int type,
	unsigned vc, int *plen);
static int otto_en_cred_read (struct otto_softc *sc, struct mbuf *m0,
        unsigned bytes, unsigned len, unsigned vc, int link);

struct otto_en otto_en_cred = {
	otto_en_cred_add,
	otto_en_cred_read
};


static struct mbuf *otto_en_cred_add (struct otto_softc *sc,
	struct mbuf *m, struct sockaddr *dst,
	unsigned char *osrc, unsigned char *odst, int type,
	unsigned vc, int *plen)
{
	if (type != sc->data.vcs[vc].etype) {
		OTTOMFREEM (m);
		return ((struct mbuf *) 0);
	}
	*plen = m_length (m);
	return (m);
}

int otto_credit_printfs = 0;

static int otto_en_cred_read (struct otto_softc *sc, struct mbuf *m0,
        unsigned bytes, unsigned len, unsigned vc, int link)
{
        int copied = 0;
	struct ether_header eh;
	struct ether_header *eptr = &eh;
	unsigned char *byteptr;
	u_short cvpi, cvci, xtype, cval;

        if (len <= OTTOMLEN && m0->m_len >= len) {
	  byteptr = (unsigned char *) mtod(m0, char *);
	  cvpi = (byteptr[0] << 4) + (byteptr[1] >> 4);
	  cvci = (byteptr[2] << 4) + (byteptr[3] >> 4);
	  xtype = (byteptr[3] & 0xf);
	  cval = (u_short) byteptr[5];
	  if (otto_credit_printfs) {
	    printf("cVPI: %d\n", cvpi);
	    printf("cVCI: %d\n", cvci);
	    printf("xtype: %d\n", xtype);
	    printf("val1: %d\n", (int) byteptr[4]);
	    printf("val2: %d\n", (int) byteptr[5]);
	    printf("val3: %d\n", (int) byteptr[6]);
	    printf("val4: %d\n", (int) byteptr[7]);
	  }
	  /* hoo boy...try to set the credit value for cvci */
	  otto_settxvc(&sc->data, cvci, -1, -1, -1, cval);
	}
	return(0);
}
