#include "otto_platform.h"

static struct mbuf *otto_en_raw_add (struct otto_softc *sc,
	struct mbuf *m, struct sockaddr *dst,
	unsigned char *osrc, unsigned char *odst, int type,
	unsigned vc, int *plen);
static int otto_en_raw_read (struct otto_softc *sc, struct mbuf *m0,
        unsigned bytes, unsigned len, unsigned vc, int link);

struct otto_en otto_en_raw = {
	otto_en_raw_add,
	otto_en_raw_read
};


static struct mbuf *otto_en_raw_add (struct otto_softc *sc,
	struct mbuf *m, struct sockaddr *dst,
	unsigned char *osrc, unsigned char *odst, int type,
	unsigned vc, int *plen)
{
	if (type != sc->data.vcs[vc].etype) {
		OTTOMFREEM (m);
		return ((struct mbuf *) 0);
	}
	*plen = m_length (m);
	return (m);
}

static int otto_en_raw_read (struct otto_softc *sc, struct mbuf *m0,
        unsigned bytes, unsigned len, unsigned vc, int link)
{
        int copied = 0;
	struct ether_header eh;
	struct ether_header *eptr = &eh;

        if (len <= OTTOMLEN && m0->m_len >= len) {
        	/* packet would fit in one small mbuf --- copy it */
	    	struct mbuf *mtmp;
		if (vc == sc->data.snmp.pkt.resyncVCI) {
				/* this is the flow control vc */
			fc_receive (sc->data.fcs,
				mtod (m0, unsigned char *), len);
			return (0);
		}
		if (vc == OTTO_FS_VCI) {
				/* this is the SNMP VCI */
			otto_fakesnmp_rcv (sc,
				mtod (m0, unsigned char *), len);
			return (0);
		}
		OTTOMGET (mtmp);
		if (mtmp != (struct mbuf *) 0) {
			bcopy (mtod (m0, char *), mtod (mtmp, char *), len);
			copied = 1;
			m0 = mtmp;
			m0->m_len = len;
		}
        }

	bcopy ((char *) &sc->is_addr[0], (char *) eptr->ether_dhost, 6);
	bzero ((char *) eptr->ether_shost, 6);
	eptr->ether_type = sc->data.vcs[vc].etype;

#ifdef __osf__
        m0->m_pkthdr.rcvif = &sc->is_if;
        m0->m_pkthdr.len = len;
#ifdef AC_IPUP
        ether_input (&sc->is_if, eptr, m0); /*len not used*/
#else
        ether_input (&sc->is_if, eptr, m0, 0); /*len not used*/
#endif
#else
	/* Dispatch this packet */
	net_read (&(sc->is_ed), eptr, m0, len, 0, 0);
#endif

        return (!copied);
}
