#ifndef _otto_ioctl_h
#define _otto_ioctl_h 1

#include <sys/ioctl.h>
#include "otto_map.h"
#include "if_ottomaint.h"
#include "otto_encapsulate.h"

typedef struct {
	unsigned ip;
	struct otto_map_mapping mapping;
} otto_mapping_t;

typedef struct {
	unsigned ip;
	unsigned length;
	struct otto_map_mapping *table;
} otto_table_t;

typedef struct {
	unsigned ip;
	struct otto_map_newmapping mapping;
} otto_newmapping_t;

typedef struct {
	unsigned ip;
	unsigned length;
	struct otto_map_newmapping *table;
} otto_newtable_t;

typedef struct {
	unsigned length;
	unsigned *table;
} otto_sched_t;

typedef struct {
	unsigned vc;		/* vc */
	int encap;		/* encapsulation */
	int etype;		/* packet types for null encapsulation */
	int useflowcontrol;	/* use flow control */
	int ignore;		/* ignore incoming packets */
	int useschedule;	/* use the schedule */
	int bandwidth;		/* bandwidth in 4096ths of a link */
	int dontarp;		/* don't use type 19 arp on this vc */
} otto_vcsetup_t;

#define OTTO_GET_ENTRY	_IOWR('o', 0, otto_table_t)	/* to dump table */
#define OTTO_DEL_ENTRY	_IOW('o', 1, otto_mapping_t)
#define OTTO_INS_ENTRY	_IOW('o', 2, otto_mapping_t)
#define OTTO_SET_VC     _IOW('o', 3, otto_vcsetup_t)
#define OTTO_GET_VC     _IOWR('o', 4, otto_vcsetup_t)
#define OTTO_SET_DEFVC 	_IOW('o', 5, unsigned)
#define OTTO_GET_DEFVC 	_IOR('o', 6, unsigned)
#define OTTO_SET_SCHED  _IOW('o', 7, otto_sched_t)
#define OTTO_GET_SCHED  _IOWR('o', 8, otto_sched_t)
#define OTTO_FLOW_RESYNC _IO('o', 9)
#define OTTO_FLOW_NORESYNC _IO('o', 10)
#define OTTO_SET_FRAMING   _IOW('o', 11, unsigned)
#define OTTO_DEL_ENTRY2	_IOW('o', 12, otto_newmapping_t)
#define OTTO_INS_ENTRY2	_IOW('o', 13, otto_newmapping_t)
#define OTTO_GET_ENTRY2	_IOWR('o', 14, otto_newtable_t)

#endif
