/* platform dependencies should go here, if possible */
/* So far this has been tested only for MIPS Ultrix */

#ifdef __osf__
/* OSF */

#define cprintf printf		/* osf doesn't distinguish printf and cprintf */

#include <machine/endian.h>

#include <sys/param.h>
#include <sys/systm.h>
#include <sys/mbuf.h>
#include <sys/buf.h>
#include <sys/protosw.h>
#include <sys/socket.h>
#include <sys/vmmac.h>
#include <sys/ioctl.h>
#include <sys/errno.h>
#include <sys/time.h>
#include <sys/kernel.h>
#include <sys/syslog.h>
#include <vm/vm_kern.h>
#include <sys/proc.h>
#include <net/if.h>
#include <net/netisr.h>
#include <net/route.h>
#include <netinet/in.h>
#include <netinet/in_var.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <netinet/ip_var.h>
#include <netinet/if_ether.h>
#include <net/ether_driver.h>
#include <netinet/if_fddi.h>
#include <machine/cpu.h>
#include <machine/scb.h>
#include <io/common/devdriver.h>
#include <io/dec/uba/ubavar.h>
#include <io/dec/tc/tc.h>


#include <sys/types.h>
#include <machine/cpuconf.h>
#include <sys/user.h>
#include <sys/ipc.h>
#include <net/if_llc.h>
#include <sys/vnode.h>
#include <sys/mman.h>
#include <vm/vm_mmap.h>
#include "packetfilter.h"       /* PACKETFILTER */

/* #define NPACKETFILTER PACKETFILTER */
#if PACKETFILTER > 0
#include <net/pfilt.h>
#endif

#ifdef __alpha
/* ALPHA OSF */
#include <hal/kn15aa.h>

#define PHYS_TO_K1(x) PHYS_TO_KSEG(x)
#define PHYS_TO_K0(x) PHYS_TO_KSEG(x)
#define wbflush()       mb()

/* caches don't need software cleaning on Alphas */
#define OTTO_CLEAN_DCACHE(addr, len)
#endif

extern vm_offset_t  OTTO_SVTOPHY ();/* routine to convert virtual to physical */

/* The OSF allocator ignores flags.  This means we can't allocate a 
   contiguous memory region dynamically.  */
#define KM_ALLOC(addr, type, length, f1, f2) ((addr) = \
	(type) kmem_alloc(kernel_map, length))
#define OTTO_KM_FREE(addr,type,length) kmem_free(kernel_map,addr,length)
#define NO_CONTIGUOUS_MALLOC

struct ether_addr {
        u_char  ether_addr_octet[6];
};


#define CONTROLLER_STRUCT	controller
#define DRIVER_STRUCT	driver
#define STD_TYPE caddr_t
#define UNIT_NUM ctlr_num

#define OTTO_IFTYPE IFT_ETHER

/* MBUF handling */
#define _OTTOMGETW(m,w)	do { MGETHDR((m), (w), MT_DATA); \
		if (m) {(m)->m_len=MHLEN;} } while (0)
#define _OTTOMCLGETW(m,w) do { \
		_OTTOMGETW(m,w); \
		if ((m)) { \
			MCLGET((m), (w)); \
			if (((m)->m_flags & M_EXT) == 0) { \
				OTTOMFREEM((m)); \
				(m) = (struct mbuf *)NULL; \
			} else { \
				(m)->m_len=MCLBYTES; \
			} \
		} \
	} while (0)
#define OTTOMLEN MHLEN

/* old versions of osf don't have m_length (!) */
#define m_length mbuf_length
extern int mbuf_length (struct mbuf *m);

#else
/* ULTRIX */

#include "../machine/pte.h"

#include "../h/param.h"
#include "../h/systm.h"
#include "../h/mbuf.h"
#include "../h/buf.h"
#include "../h/protosw.h"
#include "../h/socket.h"
#include "../h/vmmac.h"
#include "../h/ioctl.h"
#include "../h/errno.h"
#include "../h/time.h"
#include "../h/kernel.h"
#include "../h/kmalloc.h"
#include "../h/proc.h"

#include "../net/net/if.h"
#include "../net/net/netisr.h"
#include "../net/net/route.h"
#include "../net/netinet/in.h"
#include "../net/netinet/in_var.h"
#include "../net/netinet/in_systm.h"
#include "../net/netinet/ip.h"
#include "../net/netinet/ip_var.h"
#include "../net/netinet/if_ether.h"
#include "../net/net/ether_driver.h"
#include "../net/netinet/if_fddi.h"
#include "../machine/cpu.h"
#include "../machine/scb.h"
#include "../io/uba/ubavar.h"
#include "../io/tc/tc.h"

#include "packetfilter.h"       /* NPACKETFILTER */
#include "../h/types.h"
#include "../h/errlog.h"
#include "../../machine/common/cpuconf.h"
#include "../h/user.h"
#include "../h/ipc.h"
#if     NPACKETFILTER > 0
#include "../net/net/pfilt.h"
#endif
#include "../net/net/if_llc.h"

#ifdef mips
/* MIPS ULTRIX */

/* caches need software cleaning on MIPS */
#define OTTO_CLEAN_DCACHE(addr, len) clean_dcache (addr, len)

#endif

#define OTTO_KM_FREE(addr,type,length) KM_FREE(addr,type)

#define CONTROLLER_STRUCT	uba_device
#define DRIVER_STRUCT	uba_driver
#define STD_TYPE u_short
#define UNIT_NUM ui_unit
#define OTTO_IFTYPE IFT_ETHER

/* MBUF handling */
#define _OTTOMGETW(m, w)     do { MGET((m), (w), MT_DATA); } while (0)
#define _OTTOMCLGETW(m, w) do { \
		struct mbuf *p; \
		_OTTOMGETW(m, M_DONTWAIT); \
		if ((m)) { \
			MCLGET((m), p); \
			if (p == 0) { \
				OTTOMFREEM((m)); \
				(m) = (struct mbuf *)NULL; \
			} \
		} \
	} while (0)
#define OTTOMLEN MLEN

#define OTTO_SVTOPHY svtophy

#define IFQ_LOCKINIT(ifq)
#endif	/* ultrix */

void otto_nootto ();	/* call to initialize the nootto variable */

#ifdef IFF_MULTICAST
#define OTTO_IFF_MULTICAST IFF_MULTICAST
#else
#define OTTO_IFF_MULTICAST 0
#endif
#ifdef IFF_DYNPROTO
#define OTTO_IFF_DYNPROTO IFF_DYNPROTO
#else
#define OTTO_IFF_DYNPROTO 0
#endif

#ifndef M_CLUSTERSZ
#define M_CLUSTERSZ MCLBYTES
#endif 


#ifdef PFWD
#include "pfwd.h"
#endif PFWD

#if (NPFWD > 0)
#include "../pfwd/if_pfwd.h"
#include "../pfwd/if_pfwddefs.h"
#endif

/* locking */
#ifdef SMP
#define OTTO_SMP_LOCKTMP int
#define OTTO_SMP_LOCKTYPE struct lock_t
#define OTTO_SMP_LOCKINIT(x)    lockinit((x), &lock_device15_d)
#define OTTO_SMP_LOCK(lock,prev) do { (prev) = splimp(); smp_lock((lock), LK_RETRY); } while (0)
#define OTTO_SMP_UNLOCK(lock,prev) do { smp_unlock((lock)); splx(prev);} while (0)
#define OTTO_SMP_SLEEPUNLOCK(chan,pri,l,prev) do { sleep_unlock((chan),(pri),(l)); slpx (prev);} while (0)
#else
#define OTTO_SMP_LOCKTMP int
#ifdef __osf__
#define OTTO_SMP_LOCKTYPE int
#else
#define OTTO_SMP_LOCKTYPE struct lock_t
#endif
#define OTTO_SMP_LOCKINIT(x)
#define OTTO_SMP_LOCK(lock,prev) ((prev) = splimp())
#define OTTO_SMP_UNLOCK(lock,prev) splx(prev)
#define OTTO_SMP_SLEEPUNLOCK(chan,pri,l,prev) do { sleep((chan),(pri)); splx(prev); } while (0)
#endif


/* MBUF handling */
#define OTTOMFREE(mx,n)       MFREE(mx,n)
#define OTTOMFREEM(m)   m_freem(m)
#define OTTOMGET(m)     _OTTOMGETW (m, M_DONTWAIT)
#define OTTOMGETWAIT(m) _OTTOMGETW (m, M_WAIT)
#define OTTOMCLGET(m)	_OTTOMCLGETW (m, M_DONTWAIT)
#define OTTOMCLGETWAIT(m)	_OTTOMCLGETW (m, M_WAIT)

#ifdef __osf__
#define OTTO_IFSTART(ifp)	otto_ifstart (ifp)
#else
#define OTTO_IFSTART(ifp)	otto_ifstart ((ifp)->if_unit)
#endif

#include "if_ottoreg.h"
#include "if_ottomaint.h"
#include "otto_map.h"
#include "otto_measure.h"
#include "suni.h"
#include "otto_flow.h"
#include "otto_fakesnmp.h"
#include "if_ottodefs.h"
#include "ottoexec.h"

/*
 * OTTO software status per interface.
 * Based on ethernet interface structure.
 */
struct	otto_softc {
	struct	ether_driver is_ed;		/* Autonet driver */
#define	is_ac	is_ed.ess_ac			/* Ethernet common part */
#define	ztime	is_ed.ess_ztime			/* Time since last zeroed */
#define	is_if	is_ac.ac_if			/* network-visible interface */
#define	is_addr	is_ac.ac_enaddr			/* Ethernet address */
#define is_ctrblk is_ed.ess_ctrblk		/* counter block */

	struct otto_data data;
};

extern volatile otto_uword32 *ottoclockloc;
extern struct otto_softc otto_softc[];
extern struct CONTROLLER_STRUCT *ottoinfo[];

#include "otto_arp.h"
#include "otto_encapsulate.h"
#include "otto_ioctl.h"
