#include <sys/types.h>
#include <sys/mman.h>
#include "ottoclock.h"

extern caddr_t mmap ();

volatile unsigned *_talcclock;

int initottoclock (void)
{
	caddr_t a;
	int fd;

	if (_talcclock != 0) {
		return (0);
	}

	fd = open ("/dev/otto0", 0);
	if (fd == -1) {
		return (-1);
	}
	a =  mmap ((caddr_t) 0, sizeof (unsigned),
		PROT_READ, MAP_SHARED, fd, (off_t) 0);
	(void) close (fd);
	if (a == (caddr_t) -1) {
		return (-1);
	}
	_talcclock = (volatile unsigned *) a;

	return (0);
}

#ifdef TEST
int main (int argc, char *argv[])
{
	if (initottoclock () == -1) {
		perror ("initottoclock");
		exit (2);
	}
	printf ("%x\n", talcclock);
	exit (0);
}
#endif
